package betterwithmods.common.blocks;

import betterwithmods.common.BWSounds;
import betterwithmods.common.items.ItemMaterial;
import betterwithmods.common.items.tools.ItemHacksaw;
import betterwithmods.common.items.tools.ItemSoulforgeArmor;
import betterwithmods.util.InvUtils;
import betterwithmods.util.player.PlayerHelper;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyInteger;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.SoundEvents;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.Explosion;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

public class BlockSteel extends BWMBlock {

    public static final PropertyInteger HEIGHT = PropertyInteger.func_177719_a("height", 0, 15);

    public BlockSteel() {
        super(Material.field_151573_f);
        func_149672_a(SoundType.field_185852_e);
        func_149711_c(100F);
        func_149752_b(4000F);
        func_180632_j(func_176223_P().func_177226_a(HEIGHT, 0));
    }

    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        return new AxisAlignedBB(0,0,0,1, (16-state.func_177229_b(HEIGHT))/16d,1);
    }

    @Override
    public boolean func_149730_j(IBlockState state) {
        return state.func_177229_b(HEIGHT) == 0;
    }

    @Override
    public boolean func_149662_c(IBlockState state) {
        return state.func_177229_b(HEIGHT) == 0;
    }

    @Override
    public boolean func_149686_d(IBlockState state) {
        return state.func_177229_b(HEIGHT) == 0;
    }


    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, HEIGHT);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return state.func_177229_b(HEIGHT);
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        return func_176223_P().func_177226_a(HEIGHT, meta);
    }

    @Override
    public boolean func_180639_a(World worldIn, BlockPos pos, IBlockState state, EntityPlayer playerIn, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ) {
        if (worldIn.field_72995_K)
            return true;
        ItemStack stack = playerIn.func_184614_ca();
        if (stack.func_77973_b() instanceof ItemHacksaw) {
            int height = state.func_177229_b(HEIGHT);
            if (height < 15)
                worldIn.func_175656_a(pos, state.func_177226_a(HEIGHT, height + 1));
            else
                worldIn.func_175698_g(pos);
            if(!PlayerHelper.hasPart(playerIn, EntityEquipmentSlot.HEAD, ItemSoulforgeArmor.class)) {
                worldIn.func_184133_a(null,pos,BWSounds.METAL_HACKSAW, SoundCategory.BLOCKS,1.0f,0.80f);
                worldIn.func_184133_a(null,pos, SoundEvents.field_189105_bM, SoundCategory.BLOCKS,0.5f,worldIn.field_73012_v.nextFloat() * 0.5f + worldIn.field_73012_v.nextFloat()*0.5f);
            }
            stack.func_77972_a(1,playerIn);
            InvUtils.ejectStackWithOffset(worldIn, pos, ItemMaterial.getMaterial(ItemMaterial.EnumMaterial.PLATE_STEEL));
        }
        return super.func_180639_a(worldIn, pos, state, playerIn, hand, facing, hitX, hitY, hitZ);
    }

    @Override
    public boolean canEntityDestroy(IBlockState state, IBlockAccess world, BlockPos pos, Entity entity) {
        return state.func_177229_b(HEIGHT) != 0 || entity instanceof EntityPlayer;
    }

    @Override
    public void onBlockExploded(World world, BlockPos pos, Explosion explosion) {
        if (world.func_180495_p(pos).func_177229_b(HEIGHT) != 0) {
            super.onBlockExploded(world, pos, explosion);
        }
    }

    @Override
    public int getHarvestLevel(IBlockState state) {
        return 4;
    }
}
